org.jgroups

## Class ExtendedReceiverAdapter

- java.lang.Object
- - org.jgroups.ExtendedReceiverAdapter

All Implemented Interfaces:
  ExtendedMembershipListener, ExtendedMessageListener, ExtendedReceiver, MembershipListener, MessageListener, Receiver

Direct Known Subclasses:
  Draw

    public class ExtendedReceiverAdapter
    extends java.lang.Object
    implements ExtendedReceiver

Author:
  Bela Ban

### Constructor Summary

Constructors
Constructor and Description
`ExtendedReceiverAdapter()`

### Method Summary

Methods
`void` `block()` Called (usually by the FLUSH protocol), as an indication that the member should stop sending messages.
`byte[]` `getState()` Answers the group state; e.g., when joining.
`void` `getState(java.io.OutputStream ostream)` Allows an application to write a state through a provided OutputStream.
`byte[]` `getState(java.lang.String state_id)` Allows an application to provide a partial state as a byte array
`void` `getState(java.lang.String state_id, java.io.OutputStream ostream)` Allows an application to write a partial state through a provided OutputStream.
`void` `receive(Message msg)` Called when a message is received.
`void` `setState(byte[] state)` Sets the group state; e.g., when joining.
`void` `setState(java.io.InputStream istream)` Allows an application to read a state through a provided InputStream.
`void` `setState(java.lang.String state_id, byte[] state)` Allows an application to read a partial state indicated by state_id from a given state byte array parameter.
`void` `setState(java.lang.String state_id, java.io.InputStream istream)` Allows an application to read a partial state through a provided InputStream.
`void` `suspect(Address suspected_mbr)` Called whenever a member is suspected of having crashed, but has not yet been excluded.
`void` `unblock()` Called after the FLUSH protocol has unblocked previously blocked senders, and messages can be sent again.
`void` `viewAccepted(View new_view)` Called when a change in membership has occurred.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### ExtendedReceiverAdapter

    public ExtendedReceiverAdapter()

### Method Detail

#### getState

    public byte[] getState(java.lang.String state_id)

Description copied from interface: `ExtendedMessageListener`
Allows an application to provide a partial state as a byte array

Specified by:
  `getState` in interface `ExtendedMessageListener`
Parameters:
  `state_id` - id of the partial state requested
Returns:
  partial state for the given state_id

#### setState

    public void setState(java.lang.String state_id,
                byte[] state)

Description copied from interface: `ExtendedMessageListener`
Allows an application to read a partial state indicated by state_id from a given state byte array parameter.

Specified by:
  `setState` in interface `ExtendedMessageListener`
Parameters:
  `state_id` - id of the partial state requested
  `state` - partial state for the given state_id

#### receive

    public void receive(Message msg)

Description copied from interface: `MessageListener`
Called when a message is received.

Specified by:
  `receive` in interface `MessageListener`

#### getState

    public byte[] getState()

Description copied from interface: `MessageListener`
Answers the group state; e.g., when joining.

Specified by:
  `getState` in interface `MessageListener`
Returns:
  byte[]

#### setState

    public void setState(byte[] state)

Description copied from interface: `MessageListener`
Sets the group state; e.g., when joining.

Specified by:
  `setState` in interface `MessageListener`

#### viewAccepted

    public void viewAccepted(View new_view)

Description copied from interface: `MembershipListener`
Called when a change in membership has occurred. No long running actions or sending of messages should be done in this callback. If some long running action needs to be performed, it should be done in a separate thread.

Note that on reception of the first view (a new member just joined), the channel will not yet be in the connected state. This only happens when `Channel.connect(String)` returns.

Specified by:
  `viewAccepted` in interface `MembershipListener`

#### suspect

    public void suspect(Address suspected_mbr)

Description copied from interface: `MembershipListener`
Called whenever a member is suspected of having crashed, but has not yet been excluded.

Specified by:
  `suspect` in interface `MembershipListener`

#### block

    public void block()

Description copied from interface: `MembershipListener`
Called (usually by the FLUSH protocol), as an indication that the member should stop sending messages. Any messages sent after returning from this callback might get blocked by the FLUSH protocol. When the FLUSH protocol is done, and messages can be sent again, the FLUSH protocol will simply unblock all pending messages. If a callback for unblocking is desired, implement `ExtendedMembershipListener.unblock()`. Note that block() is the equivalent of reception of a BlockEvent in the pull mode.

Specified by:
  `block` in interface `MembershipListener`

#### unblock

    public void unblock()

Description copied from interface: `ExtendedMembershipListener`
Called after the FLUSH protocol has unblocked previously blocked senders, and messages can be sent again. This callback only needs to be implemented if we require a notification of that.

Note that during new view installation we provide guarantee that unblock invocation strictly follows view installation at some node A belonging to that view . However, some other message M may squeeze in between view and unblock callbacks. For more details see https://jira.jboss.org/jira/browse/JGRP-986

Specified by:
  `unblock` in interface `ExtendedMembershipListener`

#### getState

    public void getState(java.io.OutputStream ostream)

Description copied from interface: `ExtendedMessageListener`
Allows an application to write a state through a provided OutputStream. An application is obligated to always close the given OutputStream reference.

Specified by:
  `getState` in interface `ExtendedMessageListener`
Parameters:
  `ostream` - the OutputStream
See Also:
  `OutputStream.close()`

#### getState

    public void getState(java.lang.String state_id,
                java.io.OutputStream ostream)

Description copied from interface: `ExtendedMessageListener`
Allows an application to write a partial state through a provided OutputStream. An application is obligated to always close the given OutputStream reference.

Specified by:
  `getState` in interface `ExtendedMessageListener`
Parameters:
  `state_id` - id of the partial state requested
  `ostream` - the OutputStream
See Also:
  `OutputStream.close()`

#### setState

    public void setState(java.io.InputStream istream)

Description copied from interface: `ExtendedMessageListener`
Allows an application to read a state through a provided InputStream. An application is obligated to always close the given InputStream reference.

Specified by:
  `setState` in interface `ExtendedMessageListener`
Parameters:
  `istream` - the InputStream
See Also:
  `InputStream.close()`

#### setState

    public void setState(java.lang.String state_id,
                java.io.InputStream istream)

Description copied from interface: `ExtendedMessageListener`
Allows an application to read a partial state through a provided InputStream. An application is obligated to always close the given InputStream reference.

Specified by:
  `setState` in interface `ExtendedMessageListener`
Parameters:
  `state_id` - id of the partial state requested
  `istream` - the InputStream
See Also:
  `InputStream.close()`